import { _decorator, Component, Node, Button } from 'cc';
const { ccclass, property } = _decorator;

@ccclass('BaseButton')
export class BaseButton extends Button {
    private touched: boolean = false;
    private touchmil: number = 0;

    _onTouchBegan(event) {
        if (!this.interactable) return;
        super._onTouchBegan(event)
    }
    _onTouchEnded(event) {
        if (this.touched) {
            this.node.pauseSystemEvents(true)
            this._resetState();
            return;
        }
        this.touched = true;
        this.touchmil = 0;
        super._onTouchEnded(event)
    }
    update(dt) {
        //触摸计时
        super.update(dt)
        if (this.touched) {
            //防止这个数加的很大
            this.touchmil = this.touchmil + dt;
            if (this.touchmil > 1) {
                this.touchmil = 0
                this.touched = false;
                this.node.resumeSystemEvents(true)
            }
        }
    }
    onDestroy() {
        this.touched = false;
    }
    onDisable() {
        super.onDisable()
        this.touched = false;
    }
    onEnable() {
        super.onEnable()
        this.touched = false;
    }
}
