
import { _decorator, Component, Node, Label, PageView } from 'cc';
const { ccclass, property } = _decorator;

/**
 * Predefined variables
 * Name = Test
 * DateTime = Mon Feb 28 2022 10:33:29 GMT+0800 (中国标准时间)
 * Author = xielinhua
 * FileBasename = Test.ts
 * FileBasenameNoExtension = Test
 * URL = db://assets/Test.ts
 * ManualUrl = https://docs.cocos.com/creator/3.4/manual/zh/
 *
 */

@ccclass('Test')
export class Test extends Component {
    @property(Node)
    btn1: Node = null;
    @property(Node)
    btn2: Node = null;
    @property(Label)
    label: Label = null;
    @property(PageView)
    charaterPageView: PageView = null;
    // [2]
    // @property
    // serializableDummy = 0;


    private curPageIndex: number = 0
    start() {

        this.btn1.on(Node.EventType.TOUCH_END, () => {
            let index = this.curPageIndex - 1
            if (index < 0) {
                index = 3 - 1
                this.btn1.active = false
                return
            }
            this.btn2.active = true
            this.refreshPageInfo(index)

        })
        this.btn2.on(Node.EventType.TOUCH_END, () => {
            let index = this.curPageIndex + 1
            if (index > 3 - 1) {
                index = 0
                this.btn2.active = false
                return
            }
            this.btn1.active = true
            this.refreshPageInfo(index)
        })
        this.refreshPageInfo(this.curPageIndex)
    }

    onPageTurning() {
        let pageIndex = this.charaterPageView.getCurrentPageIndex();
        if (pageIndex != this.curPageIndex) {
            this.refreshPageInfo(pageIndex)
        }
    }
    update() {
        this.onPageTurning()
    }
    refreshPageInfo(index) {
        this.label.string = index + ""
        this.curPageIndex = index;
        this.charaterPageView.setCurrentPageIndex(index)
    }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.4/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.4/manual/zh/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.4/manual/zh/scripting/life-cycle-callbacks.html
 */
