
import { _decorator, Component, Node, Label, instantiate, sp, PageView, v3 } from 'cc';

const { ccclass, property } = _decorator;




@ccclass('UICharater')
export class UICharater extends Component {
    @property(Node)
    btnClose: Node = null;
    @property(PageView)
    charaterPageView: PageView = null;
    @property(Node)
    charaterItem: Node = null;
    @property(Node)
    btnLeft: Node = null;
    @property(Node)
    btnRight: Node = null;
    @property(Node)
    btnOk: Node = null;
    @property(Label)
    charaterName: Label = null;

    // [2]
    // @property
    // serializableDummy = 0;
    private curIndex: number = 1;
    private curPageIndex: number = 0
    start() {
        this.btnOk.on(Node.EventType.TOUCH_END, () => {


        })
        this.btnClose.on(Node.EventType.TOUCH_END, () => {

        })

        let cfgs = ["1", "2", "3", "4"];
        for (let i = 0; i < cfgs.length; i++) {
            let cfg = cfgs[i]
            let item = instantiate(this.charaterItem)
            item.active = true;
            this.charaterPageView.addPage(item)
        }
        this.refreshPageInfo(this.curPageIndex)
        this.btnLeft.on(Node.EventType.TOUCH_END, () => {
            let index = this.curPageIndex - 1
            if (index < 0) {
                index = cfgs.length - 1
                this.btnLeft.active = false
                return
            }
            this.btnRight.active = true
            this.refreshPageInfo(index)
        })
        this.btnRight.on(Node.EventType.TOUCH_END, () => {
            let index = this.curPageIndex + 1
            if (index > cfgs.length - 1) {
                index = 0
                this.btnRight.active = false
                return
            }
            this.btnLeft.active = true
            this.refreshPageInfo(index)
        })

    }
    refreshPageInfo(index: number) {
        this.charaterName.string = "角色" + index;
        this.curPageIndex = index;
        this.charaterPageView.setCurrentPageIndex(index)
        this.curIndex = index + 1
    }
    onPageTurning() {
        let pageIndex = this.charaterPageView.getCurrentPageIndex();
        if (pageIndex != this.curPageIndex) {
            this.refreshPageInfo(pageIndex)
        }
    }
    update() {
        this.onPageTurning()
    }
}

/**
 * [1] Class member could be defined like this.
 * [2] Use `property` decorator if your want the member to be serializable.
 * [3] Your initialization goes here.
 * [4] Your update function goes here.
 *
 * Learn more about scripting: https://docs.cocos.com/creator/3.4/manual/zh/scripting/
 * Learn more about CCClass: https://docs.cocos.com/creator/3.4/manual/zh/scripting/ccclass.html
 * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.4/manual/zh/scripting/life-cycle-callbacks.html
 */
